/*
** vector.c (C) 2013 Josh PH3NOM Pearson
**
** A loose set of functions for working with 3D Vectors
*/

#include "vector.h"

void vec3f_lerp(vec3f_t * v1, vec3f_t * v2, vec3f_t * out, float mag)
{
	out->x = v1->x + ( ( v2->x - v1->x ) * mag );
	out->y = v1->y + ( ( v2->y - v1->y ) * mag );
	out->z = v1->z + ( ( v2->z - v1->z ) * mag );
}

void vec3f_copy(vec3f_t * src, vec3f_t * dst)
{
	dst->x = src->x;
	dst->y = src->y;
	dst->z = src->z;
}

void vec3f_shift_xz(vec3f_t * p, vec3f_t * c, float mag) 
{ 
    float d[2];
	d[0] = (p->x - c->x) * mag;   
    d[1] = (p->z - c->z) * mag;   
    p->x += d[0];
	c->x += d[0]; 
    p->z += d[1];
	c->z += d[1]; 
}

void vec3f_shift(vec3f_t * p, vec3f_t * c, float mag) 
{ 
    vec3f_t d;
    d.x = (p->x - c->x) * mag;   
    d.y = (p->y - c->y) * mag;  
    d.z = (p->z - c->z) * mag;   
    p->x += d.x;
	c->x += d.x; 
    p->y += d.y;
	c->y += d.y; 
    p->z += d.z;
	c->z += d.z; 
}

void vec3f_sub(vec3f_t * v1, vec3f_t * v2, vec3f_t * v3)
{
    v3->x = v2->x - v1->x;
    v3->y = v2->y - v1->y;
    v3->z = v2->z - v1->z;
}

void vec3f_add(vec3f_t * v1, vec3f_t * v2, vec3f_t * v3)
{
    v3->x = v2->x + v1->x;
    v3->y = v2->y + v1->y;
    v3->z = v2->z + v1->z;
}

void vec3f_mul(vec3f_t * v1, vec3f_t * v2, vec3f_t * v3)
{
    v3->x = v2->x * v1->x;
    v3->y = v2->y * v1->y;
    v3->z = v2->z * v1->z;
}